#ifndef ADD_UPGRADE_PARTS_MM_H
#define ADD_UPGRADE_PARTS_MM_H

variable upgrade_part_one;
variable upgrade_part_two;
variable upgrade_part_three;
variable upgrade_part_four;
variable upgrade_part_five;
variable upgrade_part_six;
variable upgrade_part_seven;
variable upgrade_part_eight;
variable upgrade_part_nine;
variable upgrade_part_ten;
variable upgrade_part_eleven;
variable random_number_of_upgrade_parts;
variable random_upgrade_part;

procedure upgrade_parts_town_level;
procedure add_upgrade_parts;
procedure pick_upgrade_part;
procedure random_upgrade_parts;
procedure number_of_upgrade_parts;

procedure number_of_upgrade_parts begin
   call determine_town_level;
   if (town_level == 1) then 
      begin
         random_number_of_upgrade_parts := random(0,2);
      end 
   else 
      if (town_level == 2) then 
         begin
            random_number_of_upgrade_parts := random(0,3);
         end 
   else 
      if (town_level == 3) then 
         begin
            random_number_of_upgrade_parts := random(0,4);
         end 
   else 
      if (town_level == 4) then 
         begin
            random_number_of_upgrade_parts := random(1,5);
         end 
   else 
      if (town_level == 5) then 
         begin
            random_number_of_upgrade_parts := random(2,6);
         end 
   else 
      if (town_level == 6) then 
         begin
            random_number_of_upgrade_parts := random(3,7);
         end 
   else 
      begin
         random_number_of_upgrade_parts := 0;
      end
   return random_number_of_upgrade_parts;
end

procedure random_upgrade_parts begin
   random_upgrade_part := random(1,7);
   if ((random_upgrade_part == 1) and (upgrade_part_one == 0)) then 
      begin
         upgrade_part_one := 1;
         item_pid := PID_SCOPE;
      end 
   else 
      if ((random_upgrade_part == 2) and (upgrade_part_two == 0)) then 
         begin
            upgrade_part_two := 1;
            item_pid := PID_LASER_POINTER;
         end 
   else 
      if ((random_upgrade_part == 3) and (upgrade_part_three == 0)) then 
         begin
            upgrade_part_three := 1;
            item_pid := PID_LARGER_MAGAZINE;
         end 
   else 
      if ((random_upgrade_part == 4) and (upgrade_part_four == 0)) then 
         begin
            upgrade_part_four := 1;
            item_pid := PID_SPEED_LOADER;
         end
   else 
      if ((random_upgrade_part == 5) and (upgrade_part_five == 0)) then 
         begin
            upgrade_part_five := 1;
            item_pid := PID_UPGRADED_POWER_SERVOS;
         end 
   else 
      if ((random_upgrade_part == 6) and (upgrade_part_six == 0)) then 
         begin
            upgrade_part_six := 1;
            item_pid := PID_IMPROVED_CAPACITOR_BATTERY;
         end 
   else 
      if ((random_upgrade_part == 7) and (upgrade_part_seven == 0)) then 
         begin
            upgrade_part_seven := 1;
            item_pid := PID_LARGER_CAPACITOR_BATTERY;
         end 
   else 
      if ((random_upgrade_part == 8) and (upgrade_part_eight == 0)) then 
         begin
            upgrade_part_eight := 1;
            item_pid := PID_MAGNETIC_FIELD_TARGETING_SYSTEM;
         end 
   else 
      if ((random_upgrade_part == 9) and (upgrade_part_nine == 0)) then 
         begin
            upgrade_part_nine := 1;
            item_pid := PID_HOT_WIRED_PLASMA_BOLT_CHAMBER;
         end 
   else 
      if ((random_upgrade_part == 10) and (upgrade_part_ten == 0)) then 
         begin
            upgrade_part_ten := 1;
            item_pid := PID_IMPROVED_HEATER;
         end 
   else 
      if ((random_upgrade_part == 11) and (upgrade_part_eleven == 0)) then 
         begin
            upgrade_part_eleven := 1;
            item_pid := PID_ADVANCED_SUPER_BURN_MIX;
         end 
   else 
      begin
         item_pid := -1;
      end
   random_upgrade_part :=0;
   return item_pid;
end

procedure pick_upgrade_part begin
   call random_upgrade_parts;
   while (item_pid == -1) do 
      begin
         call random_upgrade_parts;
      end
end

procedure add_upgrade_parts begin
   call determine_town_level;
   call upgrade_parts_town_level;
   call number_of_upgrade_parts;
   if(random_number_of_upgrade_parts == 7) then 
      begin
         call pick_upgrade_part;
         call restock_items(item_pid, min, max, percent);
         call pick_upgrade_part;
         call restock_items(item_pid, min, max, percent);
         call pick_upgrade_part;
         call restock_items(item_pid, min, max, percent);
         call pick_upgrade_part;
         call restock_items(item_pid, min, max, percent);
         call pick_upgrade_part;
         call restock_items(item_pid, min, max, percent);
         call pick_upgrade_part;
         call restock_items(item_pid, min, max, percent);
         call pick_upgrade_part;
         call restock_items(item_pid, min, max, percent);
      end 
   else 
      if(random_number_of_upgrade_parts == 6) then 
         begin
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
         end 
   else 
      if(random_number_of_upgrade_parts == 5) then 
         begin
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
         end 
   else 
      if(random_number_of_upgrade_parts == 4) then 
         begin
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
         end 
   else 
      if(random_number_of_upgrade_parts == 3) then 
         begin
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
         end 
   else 
      if(random_number_of_upgrade_parts == 2) then 
         begin
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
         end 
   else 
      if(random_number_of_upgrade_parts == 1) then 
         begin
            call pick_upgrade_part;
            call restock_items(item_pid, min, max, percent);
         end
   min := 0;
   max := 0;
   percent := 0;
   item_pid := 0;
   upgrade_part_one := 0;
   upgrade_part_two := 0;
   upgrade_part_three := 0;
   upgrade_part_four := 0;
   upgrade_part_five := 0;
   upgrade_part_six := 0;
   upgrade_part_seven := 0;
   upgrade_part_eight := 0;
   upgrade_part_nine := 0;
   upgrade_part_ten := 0;
   upgrade_part_eleven := 0;
   random_number_of_upgrade_parts := 0;
end

procedure upgrade_parts_town_level begin
   if (town_level == 1) then 
      begin
         percent := 25;
         min := 0;
         max := 1;
      end 
   else 
      if (town_level == 2) then 
         begin
            percent := 35;
            min := 1;
            max := 2;
         end 
   else 
      if (town_level == 3) then 
         begin
            percent := 45;
            min := 1;
            max := 3;
         end 
   else 
      if (town_level == 4) then 
         begin
            percent := 55;
            min := 1;
            max := 4;
         end 
   else 
      if (town_level == 5) then 
         begin
            percent := 65;
            min := 2;
            max := 4;
         end 
   else 
      if (town_level == 6) then 
         begin
            percent := 75;
            min := 3;
            max := 6;
         end
end

#endif // ADD_UPGRADE_PARTS_MM_H